<template>
    <div>
        <div class="row mb-3 pl-sm-3">
            <div class="col-12 col-sm-12 col-md-6 col-lg-6">
                <Settings :readonly="startMazeGame" @createMap="startGame"/>
            </div>
            <div v-show="startMazeGame" class="col-12 col-sm-12 col-md-6 col-lg-6">
                <div class="row mb-3">
                    <div class="col-12 flex">
                        <canvas id="mazeCanvas"
                                :width="canvas.width"
                                :height="canvas.height"/>
                    </div>
                </div>
                <div v-if="startMazeGame" class="row mb-3">
                    <div class="col-6 flex">
                        <button type="button"
                                class="btn btn-md btn-primary"
                                @click="solveMaze">
                            Solve
                        </button>
                    </div>
                    <div class="col-6 flex">
                        <button type="button"
                                class="btn btn-md btn-primary"
                                @click="reset">
                            Reset
                        </button>
                    </div>
                </div>
                <div v-show="startMazeGame" class="row">
                    <div class="col-12 flex" :class="{'success' : maze.outputBg === 'success', 'danger': maze.outputBg === 'danger'}">
                        <p class="p-3 mb-0">
                            {{ maze.output }}
                        </p>
                    </div>
                </div>
            </div>
        </div>
        <Legend v-if="startMazeGame"/>
    </div>
</template>

<script>
import Legend from '../components/Legend';
import Maze from '../services/MazeService'
import Settings from './Settings';
import SettingsService from '../services/SettingsService'

let canvas;
let ctx;

export default {
    name: 'Maze',
    components: {Settings, Legend},
    data: () => ({
        startMazeGame: false,
        maze: {
            map: [],
            bricks: null,
            cells: null,
            output: '',
            outputBg: null,
        },
        canvas: {
            width: 1000,
            height: 600,
            status: {
                ...SettingsService.status
            },
        }
    }),

    mounted() {
        this.canvas.xEnd = this.canvas.brickColumnCount - 1;
        this.canvas.yEnd = this.canvas.brickRowsCount - 1;
    },

    methods: {

        rect(x, y, w, h, state) {
            if (state === this.canvas.status.start.code) {
                ctx.fillStyle = this.canvas.status.start.color
            } else if (state === this.canvas.status.finish.code) {
                ctx.fillStyle = this.canvas.status.finish.color
            } else if (state === this.canvas.status.empty.code) {
                ctx.fillStyle = this.canvas.status.empty.color
            } else if (state === this.canvas.status.fillBrick.code) {
                ctx.fillStyle = this.canvas.status.fillBrick.color
            } else if (state === this.canvas.status.routeFindToSolve.code) {
                ctx.fillStyle = this.canvas.status.routeFindToSolve.color
            } else {
                ctx.fillStyle = this.canvas.status.default
            }

            ctx.beginPath();
            ctx.rect(x, y, w, h);
            ctx.closePath();
            ctx.fill();
        },

        clear() {
            return ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
        },

        init() {
            canvas = document.getElementById('mazeCanvas');
            ctx = canvas.getContext('2d');
            return setInterval(this.draw, 10);
        },

        draw() {
            this.clear();

            for (let column = 0; column < this.maze.cells.cols; column++) {
                for (let row = 0; row < this.maze.cells.rows; row++) {
                    if (this.maze.map.length > 0) {
                        this.rect(this.maze.map[column][row].x, this.maze.map[column][row].y, this.maze.bricks.width, this.maze.bricks.height, this.maze.map[column][row].state);
                    }
                }
            }
        },

        startGame(data) {
            this.startMazeGame = true;
            this.maze.cells = data.cells;
            this.maze.bricks = data.bricks;
            this.init();
            this.maze.map = data.map;
        },

        solveMaze() {
            let map = Maze.solve(
                this.maze.map, this.maze.cells.cols, this.maze.cells.rows, this.maze.bricks.xStart,
                this.maze.bricks.yStart, this.maze.bricks.xEnd, this.maze.bricks.yEnd,
                this.canvas.status.empty.code, this.canvas.status.finish.code, this.canvas.status.routeFindToSolve.code
            );

            this.map = map.payload.map;

            if (map.success) {
                this.maze.output = 'You find a path to solve the maze! Congratulations!';
                this.maze.outputBg = 'success';
            } else {
                this.maze.output = 'Reset the game and try again!';
                this.maze.outputBg = 'danger';
            }

        },

        reset() {
            this.maze.map = [];
            this.canvas.output = '';
            this.canvas.outputBg = '';
            this.startMazeGame = false;
        }
    }

}
</script>
